/**
 * singleton that manages the isl
 */

object ISLContext {
  val ctx = isl.Ctx.alloc()
  val pool = scala.collection.mutable.Map.empty[String, isl.Id]

  // create new id if there is none
  def findOrCreateID(name: String) = {
    def createID(name: String) = {
      val pointer = com.sun.jna.Pointer.createConstant(0)
      isl.Id.alloc(ctx, name, pointer)
    }
    pool.getOrElseUpdate(name, createID(name))
  }
}
