import math._

/**
 * class representing an index
 */
object Index {
  val maxIndex = Index(Int.MaxValue, Int.MaxValue, Int.MaxValue)
  val minIndex = Index(Int.MinValue, Int.MinValue, Int.MinValue)
}

case class Index(i: Int, j: Int, k: Int) {
  def +(other: Index) = Index(i + other.i, j + other.j, k + other.k)

  def -(other: Index) = Index(i - other.i, j - other.j, k - other.k)

  def *(scalar: Int) = Index(i * scalar, j * scalar, k * scalar)

  def computeHaloWidth = max(abs(i), max(abs(j), abs(k)))

  override def toString = "(" + i + ", " + j + ", " + k + ")"
}
