import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.NativeLong;
import com.sun.jna.Platform;
import com.sun.jna.*;
import isl.UnionPwQpolynomial;
import isl.UnionSet;

public class LibBarvinok {
    public interface Impl  extends Library {
        Impl INSTANCE = (Impl) Native.loadLibrary("barvinok", Impl.class);

        isl.PwQpolynomial.Ptr isl_set_card(isl.Set.Ptr param);
        isl.PwQpolynomial.Ptr isl_map_card(isl.Map.Ptr param);
        isl.UnionPwQpolynomial.Ptr isl_union_set_card(isl.UnionSet.Ptr param);
        isl.UnionPwQpolynomial.Ptr isl_union_map_card(isl.UnionMap.Ptr param);
    }

    public isl.PwQpolynomial card(isl.Set s) {
        Impl barvinok = Impl.INSTANCE;
        isl.Ctx ctx = isl.Ctx.alloc();
        return new isl.PwQpolynomial(ctx, barvinok.isl_set_card(isl.Impl.isl.isl_set_copy(s.getPtr())));
    }

    public isl.UnionPwQpolynomial card(isl.UnionSet s) {
        isl.UnionPwQpolynomial PW;
        Impl barvinok = Impl.INSTANCE;
        isl.Ctx ctx = s.getCtx();
        synchronized(ctx) {
            isl.UnionSet.Ptr PP = s.getPtr();
            PP = isl.Impl.isl.isl_union_set_copy(PP);
            isl.UnionPwQpolynomial.Ptr P = barvinok.isl_union_set_card(PP);
            PW = new isl.UnionPwQpolynomial(ctx, P);
        }
        return PW;
    }

    public isl.PwQpolynomial card(isl.Map m) {
        Impl barvinok = Impl.INSTANCE;
        isl.Ctx ctx = isl.Ctx.alloc();
        return new isl.PwQpolynomial(ctx, barvinok.isl_map_card(isl.Impl.isl.isl_map_copy(m.getPtr())));
    }

    public isl.PwQpolynomial card(isl.UnionMap m) {
        Impl barvinok = Impl.INSTANCE;
        isl.Ctx ctx = isl.Ctx.alloc();
        return new isl.PwQpolynomial(ctx, barvinok.isl_union_map_card(isl.Impl.isl.isl_union_map_copy(m.getPtr())));
    }

}

